/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Cairo.xs. Do not edit this file, edit Cairo.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Cairo.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <DeviceBitmap.h>
#include <Widget.h>
#include <Image.h>
#include <Icon.h>
#include <Application.h>
#include <Printer.h>

#ifdef PRIMA_PLATFORM_X11
#include <unix/guts.h>
#define Drawable        XDrawable
#define Font            XFont
#include <cairo.h>
#include <cairo-xlib.h>
#ifdef HAVE_X11_EXTENSIONS_XRENDER_H
#include <cairo-xlib-xrender.h>
#endif
#define sys (( PDrawableSysData) var-> sysData)
UnixGuts * pguts;
#else
#include <win32/win32guts.h>
#include <cairo.h>
#include <cairo-win32.h>
#define sys (( PDrawableData) var-> sysData)
#endif

#define REQ_TARGET_APPLICATION 0
#define REQ_TARGET_WINDOW      1
#define REQ_TARGET_BITMAP      2
#define REQ_TARGET_PIXMAP      3
#define REQ_TARGET_IMAGE       4
#define REQ_TARGET_PRINTER     5

#define var (( PDrawable) widget)
PWidget_vmt CWidget;
PDeviceBitmap_vmt CDeviceBitmap;
PImage_vmt CImage;
PIcon_vmt CIcon;
PApplication_vmt CApplication;
PPrinter_vmt CPrinter;

void*
apc_cairo_surface_create( Handle widget, int request)
{
	cairo_surface_t * result = NULL;
#ifdef PRIMA_PLATFORM_X11
	Point p;
	Visual *visual;
	if ( pguts == NULL )
		pguts = (UnixGuts*) apc_system_action("unix_guts");

	XCHECKPOINT;

	switch ( request) {
	case REQ_TARGET_BITMAP:
		result = cairo_xlib_surface_create_for_bitmap(DISP, sys->gdrawable, ScreenOfDisplay(DISP,SCREEN), var->w, var->h);
		break;
	case REQ_TARGET_WINDOW:
		p = apc_widget_get_size( widget );
#ifdef HAVE_X11_EXTENSIONS_XRENDER_H
		if ( sys-> flags. layered )
			result = cairo_xlib_surface_create_with_xrender_format(DISP, sys->gdrawable, ScreenOfDisplay(DISP,SCREEN), pguts->xrender_argb_pic_format, p.x, p.y);
		else
#endif
			result = cairo_xlib_surface_create(DISP, sys->gdrawable, VISUAL, p.x, p.y);
		break;
	case REQ_TARGET_PRINTER:
		break;
	default:
#ifdef HAVE_X11_EXTENSIONS_XRENDER_H
		if ( sys-> flags. layered )
			result = cairo_xlib_surface_create_with_xrender_format(DISP, sys->gdrawable, ScreenOfDisplay(DISP,SCREEN), pguts->xrender_argb_pic_format, var->w, var->h);
		else
#endif
			result = cairo_xlib_surface_create(DISP, sys->gdrawable, VISUAL, var->w, var->h);
	}
	
	XCHECKPOINT;
#else
	result = ( request == REQ_TARGET_PRINTER ) ?
        	cairo_win32_printing_surface_create(sys-> ps) :
        	cairo_win32_surface_create(sys-> ps);
#endif
	return (void*) result;
}

static Byte rev_bytes[256];
static void
init_rev_bytes()
{
	int i = 0;
    	static const int end = 1;

    	if ( *((char *) &end) == 0x01 ) {
		// little-endian
		for ( i = 0; i < 256; i++) {
			unsigned int j,r = 0;
			Byte x = i;
			for (j = 0; j < 8; j++) {
				if ( x & 0x80 ) r |= 0x100;
				x <<= 1;
				r >>= 1;
			}
			rev_bytes[i] = r & 0xff;
		}
	} else {
		// big-endian
		for ( i = 0; i < 256; i++) rev_bytes[i] = i;
	}
}

static void
rev_memcpy(register Byte *dst, register Byte *src, register unsigned int stride)
{
	while (stride-- > 0) *dst++ = rev_bytes[*src++];
}

static void
invert( register Byte *dst, register unsigned int stride)
{
	while (stride-- > 0) {
		register Byte x = ~*dst;
		*dst++ = x;
	}
}

#define T_FROM_CAIRO  0
#define T_TO_CAIRO    0x100
#define T_LE          0
#define T_BE          0x1000
#define T_PALETTE     0
#define T_RGB         0
#define T_ARGB        0x2000
#define T_A1          0
#define T_A8          0x4000
#define T_A0          0x8000

#line 150 "Cairo.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 294 "Cairo.c"

XS_EUPXS(XS_Prima__Cairo_copy_image_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Prima__Cairo_copy_image_data)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "im, s, direction");
    {
	SV *	im = ST(0)
;
	UV	s = (UV)SvUV(ST(1))
;
	int	direction = (int)SvIV(ST(2))
;
#line 162 "Cairo.xs"
	Handle image;
	int i, w, h, dest_stride, src_stride, mask_stride, stride, selector, cformat;
	Byte *dest_buf, *src_buf, *mask_buf, *mask_buf_byte;
	Byte colorref_mono[2] = {255,0};
	Byte colorref_byte[2] = {1,0};
	cairo_surface_t * surface;
    	static const int end = 1;
#line 317 "Cairo.c"
#line 170 "Cairo.xs"
	surface = INT2PTR(cairo_surface_t*,s);
	dest_stride = cairo_image_surface_get_stride(surface);
	dest_buf    = cairo_image_surface_get_data(surface);
	cformat     = cairo_image_surface_get_format(surface);

	if ( !(image = gimme_the_mate(im)) || !kind_of( image, CImage))
		croak("bad object: not an image");
	switch (PImage(image)->type) {
	case imBW:
		if ( cformat != CAIRO_FORMAT_A1 ) croak("bad surface: not in a1 format");
		break;
	case imByte:
		if ( cformat != CAIRO_FORMAT_A8 ) croak("bad surface: not in a8 format");
		break;
	case imRGB:
		if (kind_of( image, CIcon)) {
			if (cformat != CAIRO_FORMAT_ARGB32) croak("bad surface: not in argb32 format"); 
		} else {
			if (cformat != CAIRO_FORMAT_RGB24 && cformat != CAIRO_FORMAT_ARGB32) croak("bad surface: not in rgb24/argb32 format");
		}
		break;

	}

	w   	   = PImage(image)->w;
	h   	   = PImage(image)->h;
	src_stride = PImage(image)->lineSize;
	src_buf    = PImage(image)->data + src_stride * ( h - 1);
	stride     = ( src_stride > dest_stride ) ? dest_stride : src_stride;
	selector   = (PImage(image)->type & imBPP) + (direction ? T_TO_CAIRO : T_FROM_CAIRO);

	if (cformat == CAIRO_FORMAT_ARGB32 && kind_of( image, CIcon)) {
		mask_stride   = PIcon(image)->maskLine;
		mask_buf      = PIcon(image)->mask + mask_stride * (h - 1);
		mask_buf_byte = malloc(w);
		selector |= T_ARGB | T_A1;
		if ( PIcon(image)->maskType == imbpp8) selector |= T_A8;
	} else if (direction && cformat == CAIRO_FORMAT_ARGB32) {
		mask_buf = mask_buf_byte = NULL;
		selector |= T_ARGB | T_A0;
	} else {
		mask_buf = mask_buf_byte = NULL;
		mask_stride = 0;
	}

	if ( *((char *) &end) != 0x01 && (cformat == CAIRO_FORMAT_ARGB32 || cformat == CAIRO_FORMAT_RGB24) ) {
		// big-endian mess
		selector |= T_BE;
	} else 
		selector |= T_LE;

	for ( i = 0; i < h; i++, src_buf -= src_stride, dest_buf += dest_stride, mask_buf -= mask_stride ) {
		switch(selector) {
		/* from cairo surface */
		case T_FROM_CAIRO | T_LE | T_PALETTE | 1:
/*
 * @CAIRO_FORMAT_A1: each pixel is a 1-bit quantity holding
 *   an alpha value. Pixels are packed together into 32-bit
 *   quantities. The ordering of the bits matches the
 *   endianess of the platform. On a big-endian machine, the
 *   first pixel is in the uppermost bit, on a little-endian
 *   machine the first pixel is in the least-significant bit.
*/
			rev_memcpy(src_buf, dest_buf, stride);
			invert(src_buf, stride);
			break;
		case T_FROM_CAIRO | T_LE | T_PALETTE | 8:
			memcpy(src_buf, dest_buf, w);
			break;
		case T_FROM_CAIRO | T_LE | T_RGB | 24:
			bc_rgbi_rgb(dest_buf, src_buf, w);
			break;
		case T_FROM_CAIRO | T_LE | T_ARGB | 24 | T_A1 :
			bc_rgbi_rgb(dest_buf, src_buf, w);
			{
				int j;
				Byte * alpha = dest_buf + 3;
				for (j = 0; j < w; j++, alpha += 4) mask_buf_byte[j] = (*alpha < 127) ? 0 : 1;
			}
			bc_byte_mono_cr( mask_buf_byte, mask_buf, w, colorref_byte);
			break;
		case T_FROM_CAIRO | T_LE | T_ARGB | 24 | T_A8 :
			bc_rgbi_rgb(dest_buf, src_buf, w);
			{
				int j;
				Byte * alpha = dest_buf + 3;
				for (j = 0; j < w; j++, alpha += 4) mask_buf[j] = *alpha;
			}
			break;
		case T_FROM_CAIRO | T_BE | T_RGB | 24:
			bc_ibgr_rgb(dest_buf, src_buf, w);
			break;
		case T_FROM_CAIRO | T_BE | T_ARGB | 24 | T_A1:
			bc_ibgr_rgb(dest_buf, src_buf, w);
			{
				int j;
				Byte * alpha = dest_buf;
				for (j = 0; j < w; j++, alpha += 4) mask_buf_byte[j] = (*alpha < 127) ? 0 : 1;
			}
			bc_byte_mono_cr( mask_buf_byte, mask_buf, w, colorref_byte);
			break;
		case T_FROM_CAIRO | T_BE | T_ARGB | 24 | T_A8:
			bc_ibgr_rgb(dest_buf, src_buf, w);
			{
				int j;
				Byte * alpha = dest_buf;
				for (j = 0; j < w; j++, alpha += 4) mask_buf[j] = *alpha;
			}
			break;
		/* to cairo surface */
		case T_TO_CAIRO | T_LE | T_PALETTE | 1:
			rev_memcpy(dest_buf, src_buf, stride);
			invert(dest_buf, stride);
			break;
		case T_TO_CAIRO | T_LE | T_PALETTE | 8:
			memcpy(dest_buf, src_buf, w);
			break;
		case T_TO_CAIRO | T_LE | T_RGB | 24:
			bc_rgb_rgbi(src_buf, dest_buf, w);
			break;
		case T_TO_CAIRO | T_LE | T_ARGB | 24 | T_A0:
			bc_rgb_rgbi(src_buf, dest_buf, w);
			{
				int j;
				Byte * alpha = dest_buf + 3;
				for (j = 0; j < w; j++, alpha += 4) *alpha = 0xff;
			}
			break;
		case T_TO_CAIRO | T_LE | T_ARGB | 24 | T_A1:
			bc_rgb_rgbi(src_buf, dest_buf, w);
			bc_mono_byte_cr( mask_buf, mask_buf_byte, w, colorref_mono);
			{
				int j;
				Byte * alpha = dest_buf + 3;
				for (j = 0; j < w; j++, alpha += 4) *alpha = mask_buf_byte[j];
			}
			break;
		case T_TO_CAIRO | T_LE | T_ARGB | 24 | T_A8:
			bc_rgb_rgbi(src_buf, dest_buf, w);
			{
				int j;
				Byte * alpha = dest_buf + 3;
				for (j = 0; j < w; j++, alpha += 4) *alpha = mask_buf[j];
			}
			break;
		case T_TO_CAIRO | T_BE | T_RGB | 24:
			bc_rgb_ibgr(src_buf, dest_buf, w);
			break;
		case T_TO_CAIRO | T_BE | T_ARGB | 24 | T_A0:
			bc_rgb_ibgr(src_buf, dest_buf, w);
			{
				int j;
				Byte * alpha = dest_buf;
				for (j = 0; j < w; j++, alpha += 4) *alpha = 0xff;
			}
			break;
		case T_TO_CAIRO | T_BE | T_ARGB | 24 | T_A1:
			bc_rgb_ibgr(src_buf, dest_buf, w);
			bc_mono_byte_cr( mask_buf, mask_buf_byte, w, colorref_mono);
			{
				int j;
				Byte * alpha = dest_buf;
				for (j = 0; j < w; j++, alpha += 4) *alpha = mask_buf_byte[j];
			}
			break;
		case T_TO_CAIRO | T_BE | T_ARGB | 24 | T_A8:
			bc_rgb_ibgr(src_buf, dest_buf, w);
			{
				int j;
				Byte * alpha = dest_buf;
				for (j = 0; j < w; j++, alpha += 4) *alpha = mask_buf[i];
			}
			break;
		default:
			croak("panic: unknown conversion %x", selector);
		}
	}
	if (mask_buf_byte) free( mask_buf_byte);
#line 497 "Cairo.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Prima__Cairo_surface_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Prima__Cairo_surface_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 354 "Cairo.xs"
	Handle object;
	void* context;
	int request;
	Bool need_paint_state = 0;
#line 517 "Cairo.c"
	SV *	RETVAL;
#line 359 "Cairo.xs"
	RETVAL = 0;

	if ( !(object = gimme_the_mate(sv)))
		croak("not a object");

	if ( kind_of( object, CApplication)) {
		request = REQ_TARGET_APPLICATION;
		need_paint_state = 1;
	}
	else if ( kind_of( object, CWidget))
		request = REQ_TARGET_WINDOW;
	else if ( kind_of( object, CDeviceBitmap)) 
		request = (((PDeviceBitmap)object)->type == dbtBitmap) ? REQ_TARGET_BITMAP : REQ_TARGET_PIXMAP;
	else if ( kind_of( object, CImage)) {
		request = REQ_TARGET_IMAGE;
		need_paint_state = 1;
	}
	else if ( kind_of( object, CPrinter)) {
		request = REQ_TARGET_PRINTER;
		need_paint_state = 1;
	}
	else
		croak("bad object");

	if ( need_paint_state && !PObject(object)-> options. optInDraw )
		croak("object not in paint state");
	context = apc_cairo_surface_create(object, request);

	RETVAL = newSV(0);
	sv_setref_pv(RETVAL, "Prima::Cairo::Surface", context);
#line 550 "Cairo.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Prima__Cairo); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Prima__Cairo)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Prima::Cairo::copy_image_data", XS_Prima__Cairo_copy_image_data, file, "$$$");
        (void)newXSproto_portable("Prima::Cairo::surface_create", XS_Prima__Cairo_surface_create, file, "$");

    /* Initialisation Section */

#line 143 "Cairo.xs"
{
	PRIMA_VERSION_BOOTCHECK;
	CWidget = (PWidget_vmt)gimme_the_vmt( "Prima::Widget");
	CDeviceBitmap = (PDeviceBitmap_vmt)gimme_the_vmt( "Prima::DeviceBitmap");
	CImage = (PImage_vmt)gimme_the_vmt( "Prima::Image");
	CIcon = (PIcon_vmt)gimme_the_vmt( "Prima::Icon");
	CApplication = (PApplication_vmt)gimme_the_vmt( "Prima::Application");
	CPrinter = (PPrinter_vmt)gimme_the_vmt( "Prima::Printer");
	init_rev_bytes();
}

#line 602 "Cairo.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

